from analyze.db import Database

db = Database('final_ccdb01.db')


accuracy_vs_num_ans = db.fetch('SELECT a.username, us.score, count(a.username) as claims_answered '
                  'FROM Answers as a INNER JOIN Users as us on a.username=us.username '
                  'WHERE a.unlabeled_id NOT null '
                  'GROUP BY a.username')

db.writeCSV(accuracy_vs_num_ans, "results/accuracy_vs_num_ans.csv", ['username', 'score', 'claims_answered'])


accuracy_vs_num_ans = db.fetch('SELECT a.username, us.score, count(a.username) as claims_answered '
                  'FROM Answers as a INNER JOIN Users as us on a.username=us.username '
                  'WHERE a.unlabeled_id NOT null '
                  'GROUP BY a.username')

accuracy_vs_num_color_dict = {}
new_color_dict = {}


def getColor(s, qa):
    if s >= 0.75 and qa >=16:
        return 'green'
    elif s < 0.3 or qa < 8:
        return 'red'
    else:
        return 'yellow'


for row in accuracy_vs_num_ans:
    username = row[0]
    score = row[1]
    questions_answered = row[2]
    color = getColor(score, questions_answered)
    accuracy_vs_num_color_dict[username] = [score, questions_answered, color]
    if (score, questions_answered) not in new_color_dict:
        new_color_dict[(score, questions_answered)] = {'user_count': 1, 'color': color}
    else:
        if color != new_color_dict[(score, questions_answered)]['color']:
            print("Wrong color somewhere!")
        new_color_dict[(score, questions_answered)] = {'user_count': new_color_dict[(score, questions_answered)]['user_count']+1,
                                                       'color': color}

db.writeCSVfromDict(accuracy_vs_num_color_dict, "results/accuracy_vs_num_ans_color.csv", ['username', 'score', 'claims_answered', 'color'])
db.writeCSVfromDict(new_color_dict, "results/accuracy_vs_num_ans_color_new.csv", ['score', 'claims_answered', 'user_count', 'color'])

