from analyze.db import Database
from analyze.user import User
import csv

db = Database('final_ccdb01.db')

replacement_dict = {
    'kvinne': 'female',
    'mann': 'male',
    'annet': 'other',
    'humaniora': 'humanities',
    'idrett': 'sports_education',
    'kunst': 'art_and_design',
    'medisin': 'medicine_and_ontology',
    'realfag': 'natural_science',
    'rettsvitenskap': 'jurisprudence',
    'samfunnsvitenskap': 'social_sciences',
    'yrkesfag': 'vocational_education'
}

education_avg_userscores = db.fetch('select u.education, avg(u.score) from Users as u group by u.education')
age_avg_userscores = db.fetch('SELECT u.age, avg(u.score) FROM Users as u GROUP BY u.age')
gender_avg_userscores = db.fetch('SELECT u.gender, avg(u.score) FROM Users as u GROUP BY u.gender')



education_score_result = db.fetch('select u.education, count(a.unlabeled_id) num_questions_answered, count(distinct u.username) num_users_with_score '
                                    'from Users as u inner join Answers as a on u.username=a.username '
                                    'group by u.education')

education_avg_score_result = {}
for edu_score_row, edu_avg_row in zip(education_score_result, education_avg_userscores):
    education, num_questions, num_users = edu_score_row
    avg = edu_avg_row[1]
    education = replacement_dict[education]
    education_avg_score_result[education] = [num_questions, num_users]
    education_avg_score_result[education].append(avg)

db.writeCSVfromDict(education_avg_score_result, "results/education_score_result.csv", ['education', 'num_claims_answered', 'num_users_with_score', 'average_score'])



age_score_result = db.fetch('select u.age, count(a.unlabeled_id) num_questions_answered, count(distinct u.username) num_users_with_score '
                            'from Users as u inner join Answers as a on u.username=a.username '
                            'group by u.age')
age_avg_score_result = {}
for age_score_row, age_avg_row in zip(age_score_result, age_avg_userscores):
    age, num_questions, num_users = age_score_row
    avg = age_avg_row[1]
    age_avg_score_result[age] = [num_questions, num_users]
    age_avg_score_result[age].append(avg)

db.writeCSVfromDict(age_avg_score_result, 'results/age_score_result.csv', ['age', 'num_claims_answered', 'num_users_with_score', 'average_score'])



gender_score_result = db.fetch('select u.gender, count(a.unlabeled_id) num_questions_answered, count(distinct u.username) num_users_with_score '
                               'from Users as u inner join Answers as a on u.username=a.username '
                               'group by u.gender')
gender_avg_score_result = {}
for row in gender_score_result:
    gender, num_questions, num_users = row
    gender = replacement_dict[gender]
    gender_avg_score_result[gender] = [num_questions, num_users]

for row in gender_avg_userscores:
    gender, score = row
    if score is not None:
        gender = replacement_dict[gender]
        gender_avg_score_result[gender].append(score)

db.writeCSVfromDict(gender_avg_score_result, 'results/gender_score_result.csv', ['gender', 'num_claims_answered', 'num_users_with_score', 'average_score'])
