import scrapy

# run from anaconda promt: scrapy runspider newscrawler.py
# ex with csv output file: scrapy runspider newscrawler.py -o data.csv


class Bird(scrapy.Item):
    name = scrapy.Field()


class BirdCrawler(scrapy.Spider):
    name = 'birdspider'

    def start_requests(self):
        urls = [
            'https://no.wikipedia.org/wiki/Liste_over_norske_fugler'
        ]
        for url in urls:
            yield scrapy.Request(url=url, callback=self.parse_urls)

    def parse_urls(self, response):
        sel = scrapy.Selector(response)
        t = sel.xpath("//*/table/tbody//tr")
        # print("T: ", t)

        for i in t[1:]:
            item = Bird()
            b = i.xpath("td[4]/a//text()").extract_first()
            item['name'] = b
            yield item
