import scrapy

# run from anaconda promt: scrapy runspider newscrawler.py
# ex with csv output file: scrapy runspider newscrawler.py -o data.csv


class Color(scrapy.Item):
    color = scrapy.Field()


class ColorCrawler(scrapy.Spider):
    name = 'colorspider'

    def start_requests(self):
        urls = [
            'http://i18n.skolelinux.no/nb/NorskeFargenavn.html'
        ]
        for url in urls:
            yield scrapy.Request(url=url, callback=self.parse_urls)

    def parse_urls(self, response):
        sel = scrapy.Selector(response)
        colors = sel.xpath("//*/table/tbody//tr")

        for c in colors:
            item = Color()
            color = c.xpath("td[4]//text()").extract_first()
            item['color'] = self.parse_alnum(self.getColorName(color)).capitalize()
            yield item

    def getColorName(self, color):
        first, *rest = color.split()
        return first + ''.join(word for word in rest)

    def parse_alnum(self, s):
        for ch in s:
            if not ch.isalnum():
                return s[:s.index(ch)]
        return s
