import sqlite3 as sqlite3
import csv
import pandas as pd
import numpy as np
from tabulate import tabulate


# Adds question list into BaselineQuestion table
def add_to_database(questions):
    print('Adding to database...')
    con = sqlite3.connect('ccdb01.db')
    print('type: ', type(questions))
    try:
        if isinstance(questions, tuple) or isinstance(questions, list):
            cursor = con.cursor()
            cursor.executemany('INSERT INTO BaselineQuestions (question, correct_answer, comment) VALUES (?, ?, ?)', questions)
            con.commit()
        else:
            print('not')
    except sqlite3.Error as e:
        print(e)
    finally:
        print('Done.')
        con.close()


# Reads from specialized faktisk.no .xlsx, converts to list and passes to add_to_database
def read_from_excel(file):
    df = pd.read_excel(file, names=["Påstand", "Klasse", "Kommentar"], sep="\t", encoding='ISO-8859-1')
    df['Påstand'].replace('', np.nan, inplace=True)
    df.dropna(subset=['Påstand'], inplace=True)
    print(tabulate(df, headers='keys', tablefmt='psql'))
    l = [[row[1], row[2], row[3]] for row in df.itertuples()]
    for element in l:
        if element[1] == "Egnet og verdt å sjekke":
            element[1] = 2
        elif element[1] == "Egnet men ikke verdt å sjekke":
            element[1] = 1
        else:
            element[1] = 0

    add_to_database(l)
        
read_from_excel('control.xlsx')
