var fs = require('fs');
var CronJob = require('cron').CronJob;

/* Note! "backup" folder must exist*/
function copyFile(source, target) {
    var rd = fs.createReadStream(source);
    var wr = fs.createWriteStream(target);
    return new Promise(function(resolve, reject) {
        rd.on('error', reject);
        wr.on('error', reject);
        wr.on('finish', resolve);
        rd.pipe(wr);
    }).catch(function(error) {
        rd.destroy();
        wr.end();
        throw error;
    });
}

// Runs every day at 02:30
var job = new CronJob({
    cronTime: '00 30 02 * * *',
    //cronTime: '*/5 * * * * *',
    onTick: function() {
        var date = new Date();
        console.log('Copying db at: ', date);
        copyFile('ccdb01.db', './backup/' + date.getTime() + '_ccdb01-backup.db')
    },
    start: false,
    timeZone: 'Europe/Oslo'
});
job.start();

console.log('copy file on startup');
var date = new Date();
copyFile('ccdb01.db', './backup/' + date.getTime() + '_ccdb01-backup.db');
console.log('job1 status', job.running); // job1 status true

