/*
    Create database connection
 */
var sqlite3 = require('sqlite3').verbose();
var db = new sqlite3.Database('ccdb01.db');
var dummy_data = [
    {id: 1, question: 'Trump er en gris', answer: 0, user: 'auth0|5a2134717afc143957e7a7bb'},
    {id: 2, question: 'Listhaug er tullete', answer: 0, user: 'auth0|5a2134717afc143957e7a7bb'},
    {id: 3, question: 'Hillary er president', answer: 1, user: 'auth0|5a2134717afc143957e7a7bb'},
    {id: 4, question: 'Det er jul', answer: 1, user: 'auth0|5a2134717afc143957e7a7bb'},
    {id: 5, question: 'Bob er en bil', answer: 0, user: 'auth0|5a201d46a916760a80b8c11f'},
    {id: 6, question: 'Vannet er forgiftet med klor', answer: 2, user: 'auth0|5a201d46a916760a80b8c11f'},
    {id: 7, question: 'Halloween er en norsk tradisjon', answer: 2, user: 'auth0|5a201d46a916760a80b8c11f'},
    {id: 8, question: 'Jeg liker brunost', answer: 0, user: 'auth0|5a201d46a916760a80b8c11f'},
    {id: 9, question: 'Alle menn er menn', answer: 0, user: 'auth0|5a2134717afc143957e7a7bb'},
    {id: 10, question: '7 av 10 niåringer er på snapchat', answer: 2, user: 'auth0|5a2134717afc143957e7a7bb'},
];


db.serialize(function() {
    console.log('Creating tables...');

    db.run("CREATE TABLE IF NOT EXISTS UnlabeledClaims (id INTEGER NOT NULL PRIMARY KEY, claim TEXT NOT NULL, external_id TEXT NOT NULL)");

    db.run("CREATE TABLE IF NOT EXISTS ControlClaims (id INTEGER NOT NULL PRIMARY KEY, claim TEXT NOT NULL, correct_answer INTEGER NOT NULL)");

    db.run("CREATE TABLE IF NOT EXISTS Users (username TEXT NOT NULL PRIMARY KEY, password TEXT NOT NULL, token TEXT, " +
        "age TEXT NOT NULL, gender TEXT NOT NULL, education TEXT NOT NULL, " +
        "score REAL, code_distributed INTEGER NOT NULL)");

    db.run("CREATE TABLE IF NOT EXISTS Answers (" +
        "id INTEGER NOT NULL PRIMARY KEY, " +
        "answer INTEGER NOT NULL, " +
        "unlabeled_id INTEGER, " +
        "control_id INTEGER, " +
        "username TEXT NOT NULL, " +
        "FOREIGN KEY(unlabeled_id) REFERENCES UnlabeledClaims(id) ON UPDATE CASCADE ON DELETE CASCADE, " +
        "FOREIGN KEY(control_id) REFERENCES ControlClaims(id) ON UPDATE CASCADE ON DELETE CASCADE, " +
        "FOREIGN KEY(username) REFERENCES Users(username) ON UPDATE CASCADE ON DELETE CASCADE )");

    db.run("CREATE TABLE IF NOT EXISTS Distcodes (code TEXT NOT NULL PRIMARY KEY UNIQUE)");


    /*var stmt = db.prepare('INSERT INTO Questions VALUES (?, ?)');

    console.log('Inserting dummy data...');
    for(var val of dummy_data) {
        console.log(`Inserting [${val.id}, ${val.question}]...`);
        stmt.run(val.id, val.question)
    }
    stmt.finalize();*/



});
db.close();

console.log('Finished initializing database.');