import * as log4javascript from "../../api/log4javascript";
import URLS from "../urls";

let loggerInitialized = false;

let logger = null;

function initLogger(accessToken) {
    try{
        logger = log4javascript.getLogger();
        let headers = {
            'Authorization': `Bearer ${accessToken}`,// + access_token,
            'Access-Control-Allow-Origin': `${URLS.ssl_app_url}`,
            'Access-Control-Allow-Credentials': true
        };

        let ajaxAppender = new log4javascript.AjaxAppender(`${URLS.callable_api_url}/logger`);
        ajaxAppender.setLayout(new log4javascript.JsonLayout());

        Object.keys(headers).forEach(key => {
            ajaxAppender.addHeader(key, headers[key])
        });

        ajaxAppender.setThreshold(log4javascript.Level.WARN); //ajaxAppender.setThreshold(log4javascript.Level.ERROR);

        //ajaxAppender.setTimed(true);
        //ajaxAppender.setTimerInterval(30000); // send every 10 seconds (unit is milliseconds)
        logger.addAppender(ajaxAppender);

        loggerInitialized = true;
    }
    catch (error){
        loggerInitialized = false;
    }
}

export function logging(accessToken){
    if(!loggerInitialized){
        initLogger(accessToken);
    }
    return logger;
}


/**
 * Used for logging with PopUpAppender (gives pop up window with the error messages)
 * @returns {*}
 */
export function defaultLogging() {
    return log4javascript.getDefaultLogger();
}