import React, { Component } from 'react';
import {FCW, FCWex, FNCW, FNCWex, NCW, NCWex} from "../Constants/AnswerConst";
import { Button, Collapse } from 'react-bootstrap';

class Definitions extends Component {

    constructor(){
        super();
        this.state = {
            detailed: false
        };

        this.toggle = this.toggle.bind(this);
    }

    componentWillReceiveProps(nextprops){
        let propsChanged = (nextprops.detailed !== this.props.detailed);

        let updating = (propsChanged || nextprops.detailed !== this.state.detailed);

        if(updating){
            this.setState({
                detailed: nextprops.detailed
            });
        }
    }

    toggle() {
        this.setState({detailed: !this.state.detailed});
    }

    getDefinitions(){
        return (<div className="definitions">
            <h4>Definisjoner av klassene med eksempler</h4>
            <div className="class-description">En "{FCW}" kan hverken være normativ*, prediktiv**, eller basert på allmennkunnskap. </div>
            <div className="class-example">Eks: {FCWex}.</div>
            <div className="class-description">En "{FNCW()}" er som regel basert på allmennkunnskap, men kan heller ikke være normativ* eller prediktiv**. </div>
            <div className="class-example">Eks: {FNCWex}.</div>
            <div className="class-description">En "{NCW}" er alt annet, og faller ofte i kategorien synsing.</div>
            <div className="class-example">Eks: {NCWex}.</div>

            <p className="normative">* Normativ, beskriver utsagn som kan anbefale
                en bestemt norm eller regel, være rettledende,
                eller inneholde eller innebære en vurdering. Et eksempel på dette er "Det er galt å
                torturere mennesker". (Se mer på https://snl.no/normativ) </p>
            <p>** Prediktiv, beskriver utsagn som sier noe om fremtiden, slik som spådommer.
                Et eksempel på dette er "Om 20 år vil det ikke være snø i Norge".</p>
        </div>);
    }

    getCollapsableDefinitions(){
        return (<div className="definitions_collapse">
            <Button onClick={this.toggle} className="btn-success">Definisjoner av klassene med eksempler</Button>
            <Collapse in={this.state.detailed}>
                <div className="definitions_inner">
                    <div className="class-description">En "{FCW}" kan hverken være normativ*, prediktiv**, eller basert på allmennkunnskap. </div>
                    <div className="class-example">Eks: {FCWex}.</div>
                    <div className="class-description">En "{FNCW()}" er som regel basert på allmennkunnskap, men kan heller ikke være normativ* eller prediktiv**. </div>
                    <div className="class-example">Eks: {FNCWex}.</div>
                    <div className="class-description">En "{NCW}" er alt annet, og faller ofte i kategorien synsing.</div>
                    <div className="class-example">Eks: {NCWex}.</div>

                    <p className="normative">* Normativ, beskriver utsagn som kan anbefale
                         en bestemt norm eller regel, være rettledende,
                        eller inneholde eller innebære en vurdering. Et eksempel på dette er "Det er galt å
                        torturere mennesker". (Se mer på https://snl.no/normativ) </p>
                    <p>** Prediktiv, beskriver utsagn som sier noe om fremtiden, slik som spådommer.
                        Et eksempel på dette er "Om 20 år vil det ikke være snø i Norge".</p>
                </div>
            </Collapse>
        </div>);
    }

    render() {
        const { isAuthenticated } = this.props.auth;

        if (!isAuthenticated()){
            this.props.auth.logout("invalid_token");
        }

        return (

            <div className="def">
                {
                    isAuthenticated() && (
                        (this.props.collapsable ?
                                this.getCollapsableDefinitions() :
                                this.getDefinitions()
                        )
                    )
                }
            </div>


        );
    }
}
export default Definitions;