import React, { Component } from 'react';
import { Button } from 'react-bootstrap';
import NotAuthenticated from "./NotAuthenticated";

class Done extends Component {

    goTo(route) {
        const { isAuthenticated } = this.props.auth;

        if (!isAuthenticated()) {
            this.props.auth.logout("invalid_token");
        }

        this.props.history.replace(`/${route}`)
    }

    render() {
        const { isAuthenticated } = this.props.auth;

        return (

            <div className="container">
                {
                    isAuthenticated() && (
                        <div className="done">
                            <h3>Takk for bidraget! </h3>
                            <p>Du kan nå se resultatene dine og andres ved å
                                trykke på knappen "Resultater" i menyen øverst.
                                Som takk for hjelpen ønsker vi å
                                dele ut et gavekort fra Komplett til en tilfeldig person blandt de som har klassifisert minst 20 påstander.
                                Trekningen vil bli gjennomført ved avslutning av innsamlingen (15. april). Se mer info om trekningen på
                                resultatsiden når du har klassifisert minst 20 påstander.</p>
                            <Button
                                bsStyle="primary"
                                className="btn"
                                onClick={this.goTo.bind(this, 'home')}
                            >
                                Gå tilbake til startsiden
                            </Button>
                        </div>
                    )
                }
                {
                    !isAuthenticated() && (
                        <NotAuthenticated {...this.props}/>
                    )
                }
            </div>


        );
    }
}
export default Done;