import React, { Component } from 'react';
import { Button } from 'react-bootstrap';
import NotAuthenticated from "./NotAuthenticated";

class NoMoreQuestions extends Component {

    goTo(route) {
        const { isAuthenticated } = this.props.auth;

        if (!isAuthenticated()) {
            this.props.auth.logout("invalid_token");
        }

        this.props.history.replace(`/${route}`)
    }

    render() {
        const { isAuthenticated } = this.props.auth;

        return (

            <div className="container">
                {
                    isAuthenticated() && (
                        <div className="no-more-questions">
                            <h3>Du har ingen flere påstander igjen å klassifisere. Tusen hjertelig takk for innsatsen! </h3>
                            <p>Dersom du ønsker å klassifisere flere påstander, kan du titte innom senere og se om det er lagt til flere påstander som trenger klassifisering.</p>
                            <Button
                                bsStyle="primary"
                                className="btn"
                                onClick={this.goTo.bind(this, 'home')}
                            >
                                Gå tilbake til startsiden
                            </Button>
                        </div>
                    )
                }
                {
                    !isAuthenticated() && (
                        <NotAuthenticated {...this.props}/>
                    )
                }
            </div>


        );
    }
}
export default NoMoreQuestions;