import React, {Component} from "react";

class NotAuthenticated extends Component {

    login() {
        this.goTo('login');
    }

    goTo(route){
        this.props.history.replace(`/${route}`);
    }

    render(){
        let content = null;

        if(this.props.authError){
            if(this.props.authError === "invalid_token"){
                content = (<div>
                    <h4 className="login_err">
                        <i className="fa fa-exclamation-triangle" aria-hidden="true"></i> Økten har utløpt.
                    </h4>
                    <h4>
                        Vær vennlig å {' '}
                        <a
                            style={{cursor: 'pointer'}}
                            onClick={this.login.bind(this)}
                        >
                            logge inn
                        </a>
                        {' '}for å fortsette.
                    </h4>
                </div>);
            }
            else if(this.props.authError.statusCode === 429){
                content = (<div>
                    <h4 className="login_err">
                        <i className="fa fa-exclamation-triangle" aria-hidden="true"></i> Du ble logget
                        ut fordi du lastet siden på nytt for mange ganger.
                    </h4>
                </div>);
            }
            else{
                content = (<div>
                    <h4 className="login_err">
                        <i className="fa fa-exclamation-triangle" aria-hidden="true"></i> Det har skjedd en feil.
                    </h4>
                    <p>Ta kontakt på claimcollector@gmail.com og beskriv hva du har gjort for å komme hit, så skal
                        vi hjelpe deg så fort som mulig.
                    </p>
                </div>);
            }
        }
        else{
            content = (<h4>
                Du er ikke logget inn! Vær vennlig å {' '}
                <a
                    style={{cursor: 'pointer'}}
                    onClick={this.login.bind(this)}
                >
                    logge inn
                </a>
                {' '}for å fortsette.
            </h4>);
        }

        return(
            <div className="not_auth">
                {content}
            </div>
        )
    }
}

export default NotAuthenticated;