import React, {Component} from "react";
import { Button } from 'react-bootstrap';

class ControlBar extends Component {

    constructor(props) {
        super(props);
        this.state = {
            winwidth: 0,
            winheight: 0
        };
        this.inControlbar = true;
    }

    componentWillMount(){
        this.updateDimensions();
    }

    updateDimensions() {
        if(this.inControlbar) {
            if ((this.state.winheight < 550 && window.innerHeight > 550) || (this.state.winheight > 550 && window.innerHeight < 550)) {
                //console.log("\tRerender controlbar.js because of height!, setting heigt to: ", window.innerHeight);
                this.setState({winheight: window.innerHeight});
            }
            if ((this.state.winwidth < 768 && window.innerWidth > 768) || (this.state.winwidth > 768 && window.innerWidth < 768)) {
                //console.log("\tRerender controlbar.js because of width!, setting width to: ", window.innerWidth);
                this.setState({winwidth: window.innerWidth});
            }
        }
    }
    componentDidMount(){
        window.addEventListener("resize", this.updateDimensions.bind(this));
    }

    componentWillUnmount(){
        this.inControlbar = false;
        window.removeEventListener("resize", this.updateDimensions.bind(this));
    }

    shouldComponentUpdate(nextProps, nextState){
        let changedNextBtnDisabled = nextProps.nextBtnDisabled !== this.props.nextBtnDisabled;
        let changedCurrentClaim = nextProps.currentClaim !== this.props.currentClaim;
        let changedWidthState = nextState.winwidth !== this.state.winwidth;
        let changedHeightState = nextState.winheight !== this.state.winheight;

        return (changedNextBtnDisabled || changedCurrentClaim || changedWidthState || changedHeightState);
    }

    nextBtnShouldBeDisabled(){
        return (this.props.currentClaim === this.props.lastClaim || this.props.nextBtnDisabled);
    }

    prevBtnShouldBeDisabled(){
        return (this.props.currentClaim === 0);
    }

    render(){
        const showNextClaim = this.props.showNextClaim;
        const showPrevClaim = this.props.showPrevClaim;

        return(
            <div>
                {window.innerHeight > 550 && window.innerWidth > 768 ?
                    <div className={"next-prev-btns"}>
                        <Button
                            id={"prev-btn"}
                            bsStyle="primary"
                            className={"next-and-prev-btn"}
                            onClick={showPrevClaim}
                            disabled={this.prevBtnShouldBeDisabled()}
                        >
                            Forrige påstand
                        </Button>
                        {this.props.getSubmitBtn()}
                        <Button
                            id={"next-btn"}
                            bsStyle="primary"
                            className={"next-and-prev-btn"}
                            onClick={showNextClaim}
                            disabled={this.nextBtnShouldBeDisabled()}
                        >
                            Neste påstand
                        </Button>
                    </div>
                    :
                    <div>
                        <div className={"next-prev-btns"}>
                            <Button
                                id={"prev-btn"}
                                bsStyle="primary"
                                className={"next-and-prev-btn"}
                                onClick={showPrevClaim}
                                disabled={this.prevBtnShouldBeDisabled()}
                            >
                                Forrige påstand
                            </Button>
                            <Button
                                id={"next-btn"}
                                bsStyle="primary"
                                className={"next-and-prev-btn"}
                                onClick={showNextClaim}
                                disabled={this.nextBtnShouldBeDisabled()}
                            >
                                Neste påstand
                            </Button>
                            <br/>
                        </div>
                        <div className={"last_submit"}>
                            {this.props.getSubmitBtn()}
                        </div>
                    </div>
                }
            </div>
        )
    }
}
export default ControlBar;