import React, { Component } from 'react';
import {FCW, FNCW, NCW} from "../Constants/AnswerConst";

class Question extends Component {

    constructor(){
        super();
        this.state = {
            selectedOption: -1,
        };
    }

    handleOptionChange (changeEvent){
        this.setState({
            selectedOption: changeEvent.target.value
        }, function () {
            this.props.getQuestionAnswers(this.props.keyToUse, this.state.selectedOption);
            this.props.getQuestionAnswerWithIxDict(this.props.index, this.state.selectedOption, this.props.answer);
            this.props.questionnaireEnableNextButton(this.props.index);
        });
    }

    intAnswerToText(intAnswerStr){
        let intAnswer = parseInt(intAnswerStr, 10);
        switch (intAnswer){
            case 0:
                return NCW;
            case 1:
                return FNCW();
            case 2:
                return FCW;
            default:
                return "";
        }
    }

    getCorrectAnswerDescription(correctAnswer){
        let correctAnsw = parseInt(correctAnswer, 10);
        switch (correctAnsw){
            case 0:
                return "setningen er normativ";
            case 1:
                return "setningen er basert på allmennkunnskap, men ikke er normativ";
            case 2:
                return "setningen ikke er normativ, og heller ikke allmennkunnskap"
            default:
                return ""
        }
    }

    render() {
        const claim = this.props.claim;
        //console.log("Current answer: " + this.state.selectedOption);

        return (
            <div className="question">
                <li key={this.props.keyToUse} className={this.props.class}>
                    <h3>{claim}</h3>
                    <div className="radio">
                        <label>
                            <input type="radio" value={2} checked={parseInt(this.state.selectedOption, 10) === 2} onChange={this.handleOptionChange.bind(this)} />
                            {FCW}
                        </label>
                    </div>
                    <div className="radio">
                        <label>
                            <input type="radio" value={1} checked={parseInt(this.state.selectedOption, 10) === 1} onChange={this.handleOptionChange.bind(this)}/>
                            {FNCW()}
                        </label>
                    </div>
                    <div className="radio">
                        <label>
                            <input type="radio" value={0} checked={parseInt(this.state.selectedOption, 10) === 0} onChange={this.handleOptionChange.bind(this)}/>
                            {NCW}
                        </label>
                    </div>
                    <div className="radio unsure-radio">
                        <label>
                            <input type="radio" value={3} checked={parseInt(this.state.selectedOption, 10) === 3} onChange={this.handleOptionChange.bind(this)}/>
                            Usikker
                        </label>
                    </div>
                </li>
                {this.props.testQ && this.props.answer && this.props.class === "is-current" && this.state.selectedOption !== -1 ?
                    (this.state.selectedOption !== this.props.answer ?
                        (parseInt(this.state.selectedOption, 10) === 3 ?
                                <p className="wrong"> Det riktige svaret er "{this.intAnswerToText(this.props.answer)}" fordi {this.getCorrectAnswerDescription(this.props.answer)}.</p>
                        :
                                <p className="wrong"> Dette er feil, {this.getCorrectAnswerDescription(this.props.answer)}, og det riktige svaret er derfor "{this.intAnswerToText(this.props.answer)}".</p>
                        )
                        : <p className="correct">Dette er riktig fordi {this.getCorrectAnswerDescription(this.props.answer)}.</p>)
                    : null}
            </div>
        );
    }
}
export default Question;
