import React from 'react';
import {Route, Router, Redirect} from 'react-router-dom';
import App from './App';
import Home from './Home/Home';
import Questionnaire from './Questions/Questionnaire';
import Auth from './Auth/Auth';
import history from './history';
import Done from "./Home/Done";
import Topscore from "./Home/Topscore";
import NoMoreQuestions from "./Home/NoMoreQuestions";
import Login from "./Auth/Login";
import CreateUser from "./Auth/CreateUser";

const auth = new Auth();



export const makeMainRoutes = () => {
    return (
        <Router history={history} component={App}>
            <div>
                <Route path="/" render={(props) => <App auth={auth} {...props} />}/>
                <Route path="/home" render={(props) => <Home auth={auth} {...props} />}/>
                <Route path="/classification" render={(props) => <Questionnaire auth={auth} {...props} />}/>
                <Route path="/classification-training" render={(props) => <Questionnaire auth={auth} {...props} />}/>
                <Route path="/done" render={(props) => <Done auth={auth} {...props}/>}/>
                <Route path="/results" render={(props) => <Topscore auth={auth} {...props} />}/>
                <Route path="/thanks" render={(props) => <NoMoreQuestions auth={auth} {...props} />}/>
                <Route path="/login" render={(props) => <Login auth={auth} {...props} />}/>
                <Route path="/create-user" render={(props) => <CreateUser auth={auth} {...props} />}/>


                <Route exact path="/" render={() => <Redirect to="/home" />}/>
            </div>
        </Router>
    );
};

// <Route path="/testQuestionnaire" render={(props) => <TestQuestionnaire auth={auth} {...props}/>}/>